#ifndef YUV_H
#define YUV_H

void yuv_init            (int ybits, int ubits, int vbits);

void yv12torgb_diz       (unsigned char *yuv, unsigned char *rgb, int w, int h);
void yv12torgb_raster    (unsigned char *yuv, unsigned char *rgb, int w, int h);
void yv12torgb_mmx       (unsigned char *yuv, unsigned char *rgb, int w, int h);
    
#ifndef WORDS_BIGENDIAN

#define A_VAL(p) ((unsigned char *)(p))[3]
#define R_VAL(p) ((unsigned char *)(p))[2]
#define G_VAL(p) ((unsigned char *)(p))[1]
#define B_VAL(p) ((unsigned char *)(p))[0]

#else

#define A_VAL(p) ((unsigned char *)(p))[0]
#define R_VAL(p) ((unsigned char *)(p))[1]
#define G_VAL(p) ((unsigned char *)(p))[2]
#define B_VAL(p) ((unsigned char *)(p))[3]

#endif

/* Planar YUV formats... */
/* YV12 (420)
 *         +--+
 *     +--+|V.|
 * +--+|U.||..|
 * |YY||..|+--+
 * |YY|+--+
 * +--+
 */

/* YV16 (422)
 *         +--+
 *     +--+|V.|
 * +--+|U.|+--+
 * |YY|+--+
 * +--+
 */

/* YUV444P (444)
 *       +-+
 *    +-+|V|
 * +-+|U|+-+
 * |Y|+-+
 * +-+
 */

/* Packed YUV formats */
/* IYU2 (444)
 * 
 * YUV...
 */

/* UYVY (422)
 * 
 * UYVY....
 */

/* theora == YV12 */

#endif
